/* Layout */
import Layout from '@/layout'

const clubRouter = {
  path: '/campaign',
  component: Layout,
  redirect: '/campaign/list',
  name: 'Campaign',
  meta: { title: '活动管理', icon: 'el-icon-present' },
  alwaysShow: true,
  children: [
    {
      path: 'list',
      name: 'CampaignList',
      component: () => import('@/views/campaign/list'),
      meta: { title: '运营专区', noCache: true, icon: 'el-icon-guide' }
    },
    {
      path: 'banner-edit',
      name: 'BannerEdit',
      component: () => import('@/views/campaign/banner-edit'),
      meta: { title: '轮播图编辑', noCache: true, icon: 'ma-other-notes' },
      hidden: true
    },
    {
      path: 'category-edit',
      name: 'CategoryEdit',
      component: () => import('@/views/campaign/category-edit'),
      meta: { title: '主菜单编辑', noCache: true, icon: 'ma-other-notes' },
      hidden: true
    },
    {
      path: 'special-edit',
      name: 'SpecialEdit',
      component: () => import('@/views/campaign/special-edit'),
      meta: { title: '活动编辑', noCache: true, icon: 'ma-other-notes' },
      hidden: true
    },
    {
      path: 'activity-edit',
      name: 'ActivityEdit',
      component: () => import('@/views/campaign/activity-edit'),
      meta: { title: '活动编辑', noCache: true, icon: 'ma-other-notes' },
      hidden: true
    },
    {
      path: 'activity-list',
      name: 'ActivityList',
      component: () => import('@/views/campaign/activity-list'),
      meta: { title: '活动列表', noCache: true, icon: 'el-icon-s-grid' }
    }
  ]
}

export default clubRouter
