/* Layout */
import Layout from '@/layout'

const clubRouter = {
  path: '/club',
  component: Layout,
  redirect: '/club/list',
  name: 'Club',
  meta: { title: '机构管理', icon: 'el-icon-office-building' },
  alwaysShow: true,
  children: [
    {
      path: 'list',
      name: 'List',
      component: () => import('@/views/club/list'),
      meta: { title: '机构列表', icon: 'el-icon-s-custom' }
    },
    {
      path: 'details',
      name: 'Details',
      component: () => import('@/views/club/details'),
      meta: { title: '查看资料' },
      hidden: true
    },
    {
      path: 'form',
      name: 'Form',
      component: () => import('@/views/club/form'),
      meta: { title: '添加机构', icon: 'ma-club-form' },
      hidden: true
    },
    {
      path: 'operateList',
      component: () => import('@/views/club/operateList'),
      name: 'OperateList',
      meta: { title: '查看运营人员', noCache: true, activeMenu: '/club/list' },
      hidden: true
    },
    {
      path: 'editForm',
      component: () => import('@/views/club/editForm'),
      name: 'EditForm',
      meta: { title: '编辑资料', noCache: true, activeMenu: '/club/list' },
      hidden: true
    }
  ]
}

export default clubRouter
