/* Layout */
import Layout from '@/layout'

const financeRouter = {
  path: '/finance',
  component: Layout,
  redirect: '/finance/list',
  name: 'Finance',
  meta: { title: '财务管理', icon: 'el-icon-printer' },
  alwaysShow: true,
  children: [
    {
      path: 'list',
      name: 'List',
      component: () => import('@/views/finance/list'),
      meta: { title: '收款列表', noCache: true, icon: 'el-icon-coin' }
    },
    {
      path: 'details',
      name: 'Details',
      component: () => import('@/views/finance/details'),
      meta: { title: '收款详情', noCache: true, icon: 'el-icon-coin' },
      hidden: true
    },
    {
      path: 'payment-list',
      name: 'PaymentList',
      component: () => import('@/views/finance/payment-list'),
      meta: { title: '付款列表', noCache: true, icon: 'el-icon-bank-card' }
    },
    {
      path: 'payment-details',
      name: 'PaymentDetails',
      component: () => import('@/views/finance/payment-details'),
      meta: { title: '付款详情', noCache: true, icon: 'el-icon-bank-card' },
      hidden: true
    },
    {
      path: 'payment-record',
      name: 'PaymentRecord',
      component: () => import('@/views/finance/payment-record'),
      meta: { title: '退/付款记录', noCache: true, icon: 'el-icon-bank-card' },
      hidden: true
    },
    {
      path: 'payapply-list',
      name: 'PayapplyList',
      component: () => import('@/views/finance/payapply-list'),
      meta: { title: '申请付款', noCache: true, icon: 'el-icon-wallet' }
    },
    {
      path: 'payapply-edit',
      name: 'PayapplyEdit',
      component: () => import('@/views/finance/payapply-edit'),
      meta: { title: '提交付款单', noCache: true, icon: 'el-icon-wallet' },
      hidden: true
    },
    {
      path: 'paycents-list',
      name: 'PaycentsList',
      component: () => import('@/views/finance/paycents-list'),
      meta: { title: '子订单手动分账', noCache: true, icon: 'el-icon-set-up' }
    },
    {
      path: 'paysettle-list',
      name: 'PaysettleList',
      component: () => import('@/views/finance/paysettle-list'),
      meta: { title: '子订单手动结算', noCache: true, icon: 'el-icon-set-up' }
    },
    {
      path: 'paysettle-edit',
      name: 'PaysettleEdit',
      component: () => import('@/views/finance/paysettle-edit'),
      meta: { title: '申请结算', noCache: true, icon: 'el-icon-odometer' },
      hidden: true
    },
    {
      path: 'paysettle-record',
      name: 'PaysettleRecord',
      component: () => import('@/views/finance/paysettle-record'),
      meta: { title: '结算记录', noCache: true, icon: 'el-icon-odometer' },
      hidden: true
    },
    {
      path: 'payfinance-list',
      name: 'PayfinanceList',
      component: () => import('@/views/finance/payfinance-list'),
      meta: { title: '订单财务信息', noCache: true, icon: 'el-icon-takeaway-box' }
    },
    {
      path: 'shop-record',
      name: 'ShopRecord',
      component: () => import('@/views/finance/payfinance-shop-record'),
      meta: { title: '供应商退/付款记录', noCache: true, icon: 'el-icon-takeaway-box' },
      hidden: true
    },
    {
      path: 'remit-record',
      name: 'RemitRecord',
      component: () => import('@/views/finance/payfinance-remit-record'),
      meta: { title: '收付款记录', noCache: true, icon: 'el-icon-takeaway-box' },
      hidden: true
    },
    {
      path: 'refund-record',
      name: 'RefundRecord',
      component: () => import('@/views/finance/payfinance-refund-record'),
      meta: { title: '退货/退款记录', noCache: true, icon: 'el-icon-takeaway-box' },
      hidden: true
    }
  ]
}

export default financeRouter
