/* Layout */
import Layout from '@/layout'

const floorRouter = {
  path: '/floor',
  component: Layout,
  redirect: '/floor/list',
  name: 'Floor',
  meta: { title: '楼层管理', icon: 'el-icon-school' },
  alwaysShow: true,
  children: [
    {
      path: 'list',
      name: 'FloorList',
      component: () => import('@/views/floor/list'),
      meta: { title: '楼层管理', noCache: true, icon: 'el-icon-s-operation' }
    },
    {
      path: 'edit',
      name: 'FloorEdit',
      component: () => import('@/views/floor/edit'),
      meta: { title: '楼层编辑', noCache: true, icon: 'ma-other-notes' },
      hidden: true
    }
  ]
}

export default floorRouter
