/* Layout */
import Layout from '@/layout'

const orderRouter = {
  path: '/order',
  component: Layout,
  redirect: '/order/list',
  name: 'Order',
  meta: { title: '订单管理', icon: 'el-icon-shopping-cart-1' },
  alwaysShow: true,
  children: [
    {
      path: 'list',
      name: 'List',
      component: () => import('@/views/order/list'),
      meta: { title: '订单列表', icon: 'el-icon-document-copy' }
    },
    {
      path: 'refund',
      name: 'Refund',
      component: () => import('@/views/order/refund'),
      meta: { title: '用户退款列表', icon: 'el-icon-money' }
    },
    {
      path: 'refund-detail',
      name: 'RefundDeatil',
      component: () => import('@/views/order/refund-detail'),
      meta: { title: '退款详情', noCache: true, activeMenu: '/order/refund' },
      hidden: true
    },
    {
      path: 'deliver',
      name: 'Deliver',
      component: () => import('@/views/order/deliver'),
      meta: { title: '订单发货', noCache: true, activeMenu: '/order/deliver' },
      hidden: true
    },
    {
      path: 'deliver-record',
      name: 'deliverRecord',
      component: () => import('@/views/order/deliver-record'),
      meta: { title: '发货记录', noCache: true, activeMenu: '/order/deliver' },
      hidden: true
    },
    {
      path: 'addLogistics',
      name: 'AddLogistics',
      component: () => import('@/views/order/addLogistics'),
      meta: { title: '添加物流', noCache: true, activeMenu: '/order/addLogistics' },
      hidden: true
    },
    {
      path: 'order-remarks',
      name: 'OrderRemarks',
      component: () => import('@/views/order/order-remarks'),
      meta: { title: '订单备注', noCache: true, activeMenu: '/order/order-remarks' },
      hidden: true
    },
    {
      path: 'add-remarks ',
      name: 'AddRemarks ',
      component: () => import('@/views/order/add-remarks '),
      meta: { title: '订单备注', noCache: true, activeMenu: '/order/add-remarks ' },
      hidden: true
    },
    {
      path: 'detail',
      name: 'Detail',
      component: () => import('@/views/order/detail'),
      meta: { title: '订单详情', noCache: true, activeMenu: '/order/list' },
      hidden: true
    },
    {
      path: 'logistics',
      name: 'logistics',
      component: () => import('@/views/order/logistics'),
      meta: { title: '发货记录', noCache: true, activeMenu: '/order/list' },
      hidden: true
    }
  ]
}

export default orderRouter
